uses VGA3220, TXT3220, DOS, CRT;

var
  H,M,S,S100 : Word;
  H_,M_,S_,S100_ : Word;
  Key : Char;

procedure Analog; forward;
procedure Digital; forward;



function IntToStr (IntIn : Integer) : String;

var
  StrOut : String;

begin
  Str(IntIn, StrOut);
  IntToStr := StrOut;
end;



procedure Digital;
begin
  Cls;

(* SETTING COLORS *)
  setPalette(10, 255,0,0);      (* RED *)
  setPalette(11, 0,255,0);      (* GREEN *)
  setPalette(12, 0,0,255);      (* BLUE *)
  setPalette(13, 255,255,0);    (* YELLOW *)
  setPalette(14, 0,255,255);    (* CYAN *)
  setPalette(15, 255,0,150);    (* DARK MAGENTA *)
  setPalette(16, 255,255,100);  (* LIGHT YELLOW *)

(* DRAW THE MENU RIGHT *)
  OutTextXY(150,6, 'PascalClock by S. B. Adam', 14);
  Line(250,30, 250,180, 12);
  OutTextXY(226,20, 'Key', 16);
  OutTextXY(230,40, 'A', 16);
  OutTextXY(255,40, 'Analog', 16);
  OutTextXY(230,50, 'D', 15);
  OutTextXY(255,50, '-Digital', 15);
  OutTextXY(226,60, 'Esc', 16);
  OutTextXY(255,60, 'Quit', 16);

(* PAINT THE BORDER ROUND THE CLOCK *)
  Line( 50, 75,150, 75, 13);
  Line( 50, 75, 50,125, 13);
  Line( 50,125,150,125, 13);
  Line(150,125,150, 75, 13);

(* LOOP START *)
  repeat
    H_ := H;
    M_ := M;
    S_ := S;
    S100_ := S100;
    getTime(H,M,S,S100);
    if H_ <> H then OutTextXY( 70,100, IntToStr(H_), 0);
    if M_ <> M then OutTextXY( 90,100, IntToStr(M_), 0);
    if S_ <> S then OutTextXY(110,100, IntToStr(S_), 0);
    OutTextXY( 70,100, IntToStr(H), 12);
    OutTextXY( 90,100, IntToStr(M), 11);
    OutTextXY(110,100, IntToStr(S), 10);
    if keypressed then begin            (* KEY PRESSED ? *)
      Key := Readkey;                   (* YES, READ IT *)
      case Key of
        'A', 'a' : begin               (* "A"-PRESSED *)
          Analog;
            (* RUNNING PROCEDURE "ANALOG" *)
          key := Chr(27);
            (* KEY IS "ESC" SO LOOP WILL END *)
        end;
      end;
    end;
  until Key = chr(27);
(* LOOP END IF "ESC" PRESSED*)

end;

procedure Analog;
begin
  Cls;

(* SETTING COLORS *)
  setPalette(10, 255,0,0);      (* RED *)
  setPalette(11, 0,255,0);      (* GREEN *)
  setPalette(12, 0,0,255);      (* BLUE *)
  setPalette(13, 255,255,0);    (* YELLOW *)
  setPalette(14, 0,255,255);    (* CYAN *)
  setPalette(15, 255,0,150);    (* DARK MAGENTA *)
  setPalette(16, 255,255,100);  (* LIGHT YELLOW *)

(* MENU RIGHT *)
  OutTextXY(150,6, 'PascalClock by S. B. Adam', 14);
  Line(250,30, 250,180, 12);
  OutTextXY(226,20, 'Key', 16);
  OutTextXY(230,40, 'A', 15);
  OutTextXY(255,40, '-Analog', 15);
  OutTextXY(230,50, 'D', 16);
  OutTextXY(255,50, 'Digital', 16);
  OutTextXY(226,60, 'Esc', 16);
  OutTextXY(255,60, 'Quit', 16);

(* PAINT THE BORDER ROUND THE CLOCK *)
  Circle(100,100, 60, 13);

(* RESET TIME *)
  H := 0;
  M := 0;
  S := 0;
  S100 := 0;

(* LOOP START *)
  repeat

    H_ := H;
    M_ := M;
    S_ := S;
    S100_ := S100;

    getTime(H,M,S,S100);  (* READ SYSTEM-TIME *)

    if S_ <> S then     (* IF SECONDS CHANGED... *)
      (* OVERDRAW OLD TIME *)
      Line(round(cos(Pi*2/60*S_-Pi/2)*3)+100,round(sin(Pi*2/60*S_-Pi/2)*3)+100,
        round(cos(Pi*2/60*S_-Pi/2)*40)+100,round(sin(Pi*2/60*S_-Pi/2)*40)+100, 0);
      (* DRAW NEW TIME *)
    Line(round(cos(Pi*2/60*S-Pi/2)*3)+100,round(sin(Pi*2/60*S-Pi/2)*3)+100,
      round(cos(Pi*2/60*S-Pi/2)*40)+100,round(sin(Pi*2/60*S-Pi/2)*40)+100, 10);

    if M_ <> M then     (* IF MINUTES CHANGED... *)
      (* OVERDRAW OLD TIME *)
      Line(round(cos(Pi*2/60*M_-Pi/2)*3)+100,round(sin(Pi*2/60*M_-Pi/2)*3)+100,
        round(cos(Pi*2/60*M_-Pi/2)*45)+100,round(sin(Pi*2/60*M_-Pi/2)*45)+100, 0);
      (* DRAW NEW TIME *)
    Line(round(cos(Pi*2/60*M-Pi/2)*3)+100,round(sin(Pi*2/60*M-Pi/2)*3)+100,
      round(cos(Pi*2/60*M-Pi/2)*45)+100,round(sin(Pi*2/60*M-Pi/2)*45)+100, 11);

    if H_ <> H then     (* IF HOURS CHANGED... *)
      (* OVERDRAW OLD TIME *)
      Line(round(cos(Pi*2/12*H_-Pi/2)*3)+100,round(sin(Pi*2/12*H_-Pi/2)*3)+100,
        round(cos(Pi*2/12*H_-Pi/2)*59)+100,round(sin(Pi*2/12*H_-Pi/2)*59)+100, 0);
      (* DRAW NEW TIME *)
    Line(round(cos(Pi*2/12*H-Pi/2)*3)+100,round(sin(Pi*2/12*H-Pi/2)*3)+100,
      round(cos(Pi*2/12*H-Pi/2)*59)+100,round(sin(Pi*2/12*H-Pi/2)*59)+100, 12);

    if Keypressed then begin             (* KEY PRESSED ? *)
      Key := Readkey;                    (* YES, READ IT *)
      case Key of
        'D', 'd' : begin                (* "D"-PRESSED *)
          Digital;
            (* RUN DIGITAL *)
          Key := chr(27);
            (* KEY IS "ESC" SO LOOP WILL END *)
        end;
      end;
    end;
  until Key = chr(27);
(* LOOP END IF "ESC" PRESSED *)

end;

BEGIN

(* INITIALIZE VGA320x200/256color MODE (DEC-19, HEX-13) *)
  InitGraph($13);

(* JUMP TO ANALOG *)
  Analog;

(* INITIALIZE TEXTMODE (HEX-3) *)
  InitGraph($3);
END.